#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QWidget>
#include <QMainWindow>
#include <QGraphicsView>
#include <QGraphicsScene>
#include <QStandardItemModel>

#include <brlcad/ConstDatabase.h>
#include <brlcad/cicommon.h>

class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    BRLCAD::ConstDatabase database;
    const char *databaseTitle;
    QGraphicsScene *scene;
    QGraphicsView *view;
    QMenu *fileMenu;
    QMenu *viewMenu;
    QStandardItemModel *model;
    QDockWidget *dockWidget;
    BRLCAD::Vector3D min;
    BRLCAD::Vector3D max;
    BRLCAD::Vector2D *renderSize = new BRLCAD::Vector2D(720,410);
    int margin = 20;

    explicit MainWindow(QWidget *parent = 0);
    void openDialog();
    void open(char *filePath);
    void createListDockWidget();
    void objectClicked(const QModelIndex &index);
    BRLCAD::Vector2D bLRCordsToDACords(BRLCAD::Vector3D bLRCords);
    BRLCAD::Vector3D dACordsToBLRCords(BRLCAD::Vector2D dACords);
    void drawSelectedObjectRayTrace();
};

#endif